# Absolut Engine by Daniel Duris (c) 2001-2004
# Absolut Engine v1.70 database format

CREATE TABLE ae_modules (
  ID INT(10) UNSIGNED DEFAULT '1' NOT NULL AUTO_INCREMENT,
  module varchar(255),
  version varchar(10),
  author varchar(255),
  website varchar(255),
  description TEXT,
  directory varchar(255),
  menu1 tinyint,
  menu2 tinyint,
  menu3 tinyint,
  guestmodify tinyint,
  PRIMARY KEY (ID)
);

CREATE TABLE ae_sections (
  ID INT(10) UNSIGNED DEFAULT '1' NOT NULL AUTO_INCREMENT,
  section varchar(255),
  PRIMARY KEY (ID)
);

CREATE TABLE ae_images (
  ID INT(10) UNSIGNED DEFAULT '1' NOT NULL AUTO_INCREMENT,
  description varchar(255),
  file1 varchar(255),
  file2 varchar(255),
  file3 varchar(255),
  file4 varchar(255),
  file5 varchar(255),
  file6 varchar(255),
  file7 varchar(255),
  file8 varchar(255),
  file9 varchar(255),
  file10 varchar(255),
  filedescription1 varchar(255),
  filedescription2 varchar(255),
  filedescription3 varchar(255),
  filedescription4 varchar(255),
  filedescription5 varchar(255),
  filedescription6 varchar(255),
  filedescription7 varchar(255),
  filedescription8 varchar(255),
  filedescription9 varchar(255),
  filedescription10 varchar(255),
  authorID INT(10) UNSIGNED,
  PRIMARY KEY (ID)
);

CREATE TABLE ae_files (
  ID INT(10) UNSIGNED DEFAULT '1' NOT NULL AUTO_INCREMENT,
  description varchar(255),
  file1 varchar(255),
  file2 varchar(255),
  file3 varchar(255),
  file4 varchar(255),
  file5 varchar(255),
  authorID INT(10) UNSIGNED,
  PRIMARY KEY (ID)
);

CREATE TABLE ae_articles (
  ID INT(10) UNSIGNED DEFAULT '1' NOT NULL AUTO_INCREMENT,
  title TEXT,
  beginning TEXT,
  text TEXT,
  authorID INT(10) UNSIGNED,
  adate date,
  atime time,
  sectionID INT(10) UNSIGNED,
  imagesetID INT(10) UNSIGNED,
  filesetID INT(10) UNSIGNED,
  priority tinyint,
  status tinyint,
  filename varchar(255),
  PRIMARY KEY (ID)
);

CREATE TABLE ae_stats (
  ID INT(10) UNSIGNED DEFAULT '1' NOT NULL AUTO_INCREMENT,
  articleID INT(10) UNSIGNED,
  views INT(10) UNSIGNED,
  PRIMARY KEY (ID)
);

CREATE TABLE ae_relatedarticles (
  ID INT(10) UNSIGNED DEFAULT '1' NOT NULL AUTO_INCREMENT,
  articleID INT(10) UNSIGNED,
  relatedID INT(10) UNSIGNED,
  PRIMARY KEY (ID)
);

# position: 1-admin, 2-editor in chief, 3-editor
# language: EN - english, SK - slovak etc... ISO shorts - same as domain (.sk,.de,.no etc.)
CREATE TABLE ae_users (
  ID INT(10) UNSIGNED DEFAULT '1' NOT NULL AUTO_INCREMENT,
  user varchar(30),
  password varchar(100),
  fullname varchar(100),
  position tinyint,
  email varchar(255),
  language varchar(2),
  photo varchar(255),
  otherinfo text,
  PRIMARY KEY (ID)
);

CREATE TABLE ae_login (
  ID INT(10) UNSIGNED DEFAULT '1' NOT NULL AUTO_INCREMENT,
  userID INT(10) UNSIGNED,
  loginID varchar(100),
  logtime varchar(100),
  PRIMARY KEY (ID)
);

INSERT INTO ae_users VALUES(NULL,'admin','21232f297a57a5a743894a0e4a801fc3','Administrator','1','youremail@yourdomain.com','EN','','');